# Drift-in-MOX-Sensor-Dataset-Reveals-Limitations-for-Gas-Classification-Benchmarks

## Authors 
Nik Dennler (n.dennler2@herts.ac.uk), Shavika Rastogi, Jordi Fonollosa, Andre van Schaik, Michael Schmuker (m.schmuker@biomachinelearning.net)

## Citation
If you use this code or parts thereof, please make sure to cite the following publication accordingly:

[Dennler2022]: N. Dennler, S. Rastogi, J. Fonollosa, A. v. Schaik, M. Schmuker, Drift in a Popular Metal Oxide Sensor Dataset Reveals Limitations for Gas Classification Benchmarks, Sensors and Actuators B: Chemical,
2022, 131668, ISSN 0925-4005, https://doi.org/10.1016/j.snb.2022.131668.

## Description 
In this work, we report on our findings of sensor drift in the metal oxide sensor dataset originally published by Vergara et. al [1]. This notebook displays the code used in our analysis, reproducing the figures in our preprint.

[1]: A. Vergara, J. Fonollosa, J. Mahiques, M. Trincavelli, N. Rulkov, R. Huerta, On the performance of gas sensor arrays in open sampling systems using inhibitory support vector machines, Sensors and Actuators B: Chemical 185 (2013) 462–477. doi:10.1016/j.snb.2013.05.027

## Setup
### Clone repository
```
git clone git@github.com:BioMachineLearning/Drift-in-MOX-Sensor-Dataset-Reveals-Limitations-for-Gas-Classification-Benchmarks.git
```

### Get data and place in according directory
* Make sure you have enough space on your harddrive (~120GB). 
* Download the following ```.zip``` file fron the ICU database: [WTD_upload.zip](http://archive.ics.uci.edu/ml/machine-learning-databases/00251/WTD_upload.zip). 
* Extract into subdirectory ```src/data/```

### Set up python environment
* Make sure you have [conda](https://docs.conda.io/projects/conda/en/latest/user-guide/install/index.html) installed on your computer.
* Create conda environment from ```.yml```-file:
  ```
  conda env create -f vergara2013drift.yml
  ```
  Note: This environment has been produced and tested on a Ubuntu 18.04 machine, but is expected to work on other platforms as well.
* Activate environment:
  ```
  conda activate vergara2013drift
  ```
## Run Analysis
To run the analysis, run the following Python file: 
  ```
  python src/run.py
  ```
The manuscript figures 1[b,c], 2[a,b,c,d,e], 3[a,b,c,d] will be produced and saved in ```src/output```. 
