"""
   Copyright 2022 Nik Dennler

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
"""
GasNames = {  # gas_conc(ppm)
    1: "Acetaldehyde_500",
    2: "Acetone_2500",
    3: "Ammonia_10000",
    4: "Benzene_200",
    5: "Butanol_100",
    6: "CO_1000",
    7: "CO_4000",
    8: "Ethylene_500",
    9: "Methane_1000",
    10: "Methanol_200",
    11: "Toluene_200",
}

GasIndices = {v: k for k, v in GasNames.items()}

skip_gas_full = ["CO_1000"]
skip_gas_restricted = [
    "CO_1000",
    "Acetaldehyde_500",
    "Acetone_2500",
    "Ammonia_10000",
    "Benzene_200",
    "CO_4000",
    "Methane_1000",
    "Toluene_200",
]

wind_speeds = {
    1: "fan_setPoint_000",
    2: "fan_setPoint_060",
    3: "fan_setPoint_100",
}

hotplate_voltages = {
    1: "board_setPoint_400V",
    2: "board_setPoint_450V",
    3: "board_setPoint_500V",
    4: "board_setPoint_550V",
    5: "board_setPoint_600V",
}

source_distances = {
    1: 0.25,
    2: 0.50,
    3: 0.98,
    4: 1.18,
    5: 1.40,
    6: 1.45,
}

modules_full = [5]
modules_restricted = [3]

sensors_all = [1, 2, 3, 4, 5, 6, 7, 8]
sensors_full = [2, 3, 4, 5, 6, 7, 8]
sensors_restricted = [2, 3, 5, 6, 7, 8]


# Select data
columns_all = [f"B{m}S{s}" for s in sensors_all for m in modules_full]
columns_full = [f"B{m}S{s}" for s in sensors_full for m in modules_full]
columns_restricted = [
    f"B{m}S{s}" for s in sensors_restricted for m in modules_restricted
]


all_trials = list(range(1, 20 + 1))
all_locs = list(range(1, 6 + 1))
all_boards = list(range(1, 9 + 1))
eps = 0.001


markerstyles = ["o", "v", "^", "s", "+", "*", "x"]

markers = {  # gas_conc(ppm)
    1: "o",
    2: "v",
    3: "^",
    4: ">",
    5: "D",
    # 6: 'CO_1000',
    7: "s",
    8: "X",
    9: "P",
    10: "<",
    11: "*",
}

if __name__ == "__main__":
    print(1.0 / (len(GasIndices) - len(skip_gas)))
