# The `plumy` package


Originally conceived by Michael Schmuker and Viktor Bahr. Extended by Voktor Bahr in the course of his Bachelor Thesis in Bioinformatics at FU Berlin, 2014 "Spectral analysis of electronic nose data", carried out in the BioMachineLearning group (part of AG Neuroinformatics), and supervised by Michael Schmuker. Further extended by Michael Schmuker during the preparation of the manuscript "Exploiting plume structure to decode gas source distance using metal-oxide gas sensors".

**The `plumy` framework**

The `plumy` framework, written in python 2.7 provides the means to
load (`plumy.utils`), analyze and visualize (`plumy.plot`) the data
generated by A. Vergara et al. in 2013 (available on
[UCI Machine learning Repository](https://archive.ics.uci.edu/ml/datasets/Gas+sensor+arrays+in+open+sampling+settings)).

**Usage**

Plumy needs the following 3rd party python packages to run properly:

+ `NumPy`
+ `SciPy`
+ `MatplotLib`
+ `pandas`
+ (Optional: `ipython`)

To get familiar with the usage have a look at the *ipython notebooks* in
the `'./ipnotebooks'` folder.
